export var BITS = 5;
export var SHIFT0 = 0;
export var SHIFT1 = SHIFT0 + BITS;
export var SHIFT2 = SHIFT1 + BITS;
export var SHIFT3 = SHIFT2 + BITS;
export var calculateOffset = function (index, shift) {
    return Math.floor(index / (1 << shift));
};
export var calculateRow = function (index, shift) {
    return (index >>> shift) & ((1 << BITS) - 1);
};
export var calculateMask = function (index, shift) {
    return 1 << calculateRow(index, shift);
};
export var nextPowerOfTwo = function (index) {
    return Math.pow(2, Math.ceil(Math.log(index) / Math.log(2)));
};
export var copyArrays = function (source, target) {
    if (source) {
        for (var i = 0; i < source.length; i += 1) {
            target[i] = source[i];
        }
    }
    return target;
};
export function countTrailingZeros(v) {
    var c = 32;
    v &= -v;
    if (v)
        c--;
    if (v & 0x0000FFFF)
        c -= 16;
    if (v & 0x00FF00FF)
        c -= 8;
    if (v & 0x0F0F0F0F)
        c -= 4;
    if (v & 0x33333333)
        c -= 2;
    if (v & 0x55555555)
        c -= 1;
    return c;
}
//# sourceMappingURL=Utils.js.map